using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace UndoRedoTest.Commands
{
	class DrawCircle: ICommand
	{
		Image _oldData;

		#region ICommand Members

		public void Run (Document doc)
		{
			Image image;

			if (_oldData != null)
			{
				image = (Image)_oldData.Clone ();
			}
			else
			{
				image = new Bitmap (150, 150);
			}

			Graphics gr = Graphics.FromImage (image);

			using (Pen pen = new Pen (Color.Black) )
			{
				gr.DrawEllipse (pen, 0, 0, 130, 130);
			}

			doc.SetData (image);
		}

		public void Undo (Document doc)
		{
			doc.SetData (_oldData);
		}

		public void Save (Document doc)
		{
			_oldData = doc.GetData ();
		}

		#endregion
	}
}
