using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace UndoRedoTest.Commands
{
	class DrawRect: ICommand
	{
		Image _oldData;

		#region ICommand Members

		public void Run (Document doc)
		{
			Image image;

			if (_oldData != null)
			{
				image = (Image)_oldData.Clone ();
			}
			else
			{
				image = new Bitmap (200, 200);
			}

			Graphics gr = Graphics.FromImage (image);

			using (Brush brush = new SolidBrush (Color.Red))
			{
				gr.FillRectangle (brush, 20, 20, 130, 130);
			}

			doc.SetData (image);
		}

		public void Undo (Document doc)
		{
			doc.SetData (_oldData);
		}

		public void Save (Document doc)
		{
			_oldData = doc.GetData ();
		}

		#endregion
	}
}
