using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace UndoRedoTest
{
	/// <summary>
	///        
	/// </summary>
	abstract class DocumentReader
	{
		protected Image _data;

		protected UndoRedoManager _manager;

		public Image GetData ()
		{
			if (_data != null)
			{
				return (Image)_data.Clone ();
			}

			return null;
		}

		public bool IsEmptyUndoList
		{
			get
			{
				return _manager.IsEmptyUndoList;
			}
		}

		public bool IsEmptyRedoList
		{
			get
			{
				return _manager.IsEmptyRedoList;
			}
		}

		/// <summary>
		///  
		/// </summary>
		/// <param name="command"></param>
		public void RunCommand (ICommand command)
		{
			_manager.RunCommand (command);
		}

		public void Undo ()
		{
			_manager.Undo ();
		}

		public void Redo ()
		{
			_manager.Redo ();
		}

		public delegate void DataUpdatedDelegate (DocumentReader sender);

		/// <summary>
		/// ,  ,   
		/// </summary>
		public event DataUpdatedDelegate DataUpdated;

		protected void OnDataUpdated ()
		{
			if (DataUpdated != null)
			{
				DataUpdated (this);
			}
		}
	}
}
