using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using UndoRedoTest.Commands;

namespace UndoRedoTest
{
	public partial class MainForm : Form
	{
		DocumentReader _doc = new Document ();

		public MainForm ()
		{
			InitializeComponent ();

			_doc.DataUpdated += new DocumentReader.DataUpdatedDelegate (_doc_DataUpdated);

			UpdateUndoRedoButtons ();
		}

		void UpdateUndoRedoButtons ()
		{
			UndoBtn.Enabled = !_doc.IsEmptyUndoList;
			RedoBtn.Enabled = !_doc.IsEmptyRedoList;
		}

		void _doc_DataUpdated (DocumentReader sender)
		{
			pictureBox.Image = _doc.GetData ();

			UpdateUndoRedoButtons ();
		}
		

		private void loadBtn_Click (object sender, EventArgs e)
		{
			_doc.RunCommand (new LoadImage ());
		}

		private void RectBtn_Click (object sender, EventArgs e)
		{
			_doc.RunCommand (new DrawRect ());
		}

		private void DrawCircleBtn_Click (object sender, EventArgs e)
		{
			_doc.RunCommand (new DrawCircle ());
		}

		private void UndoBtn_Click (object sender, EventArgs e)
		{
			_doc.Undo ();
		}

		private void RedoBtn_Click (object sender, EventArgs e)
		{
			_doc.Redo ();
		}
	}
}