using System;
using System.Collections.Generic;
using System.Text;

namespace UndoRedoTest
{
	class UndoRedoManager
	{
		/// <summary>
		///     
		/// </summary>
		List<ICommand> _undoList = new List<ICommand> ();

		public bool IsEmptyUndoList
		{
			get
			{
				return _undoList.Count == 0;
			}
		}

		/// <summary>
		///     
		/// </summary>
		List<ICommand> _redoList = new List<ICommand> ();

		public bool IsEmptyRedoList
		{
			get
			{
				return _redoList.Count == 0;
			}
		}

		Document _doc;

		public UndoRedoManager (Document doc)
		{
			_doc = doc;
		}

		public void RunCommand (ICommand command)
		{
			_undoList.Add (command);
			_redoList.Clear ();

			command.Save (_doc);
			command.Run (_doc);
		}

		public void Undo ()
		{
			ICommand command = _undoList[_undoList.Count - 1];

			_redoList.Add (command);
			_undoList.RemoveAt (_undoList.Count - 1);

			command.Undo (_doc);

		}

		public void Redo ()
		{
			int index = _redoList.Count - 1;

			ICommand command = _redoList[index];

			_undoList.Add (command);
			_redoList.RemoveAt (index);

			command.Save (_doc);
			command.Run (_doc);

		}
	}
}
